<?php

namespace app\models;

use Yii;
use yii\helpers\VarDumper;

/**
 * This is the model class for table "mantu".
 *
 * @property int $id_child
 * @property string $dat
 * @property string $el1
 * @property string $el2
 * @property string $coment
 *
 * @property Deti $child
 */
class Mantu_new extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'mantu';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id_child', 'dat'], 'required'],
            [['id_child'], 'integer'],
            [['dat'], 'safe'],
            [['el1', 'el2'], 'string', 'max' => 10],
            [['coment'], 'string', 'max' => 1000],
            [['el1','el2','coment'],'default','value' => ''],
            [['id_child', 'dat'], 'unique', 'targetAttribute' => ['id_child', 'dat']],
//            [['id_child'], 'exist', 'skipOnError' => true, 'targetClass' => Deti::className(), 'targetAttribute' => ['id_child' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id_child' => 'Id Child',
            'dat' => 'Dat',
            'el1' => 'El1',
            'el2' => 'El2',
            'coment' => 'Coment',
        ];
    }

    /**
     * Gets query for [[Child]].
     *
     * @return \yii\db\ActiveQuery|\app\models\query\DetiQuery
     */
    public function getChild()
    {
        return $this->hasOne(Deti::className(), ['id' => 'id_child']);
    }

    /**
     * {@inheritdoc}
     * @return \app\models\query\MantuQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new \app\models\query\MantuQuery(get_called_class());
    }

    public function afterSave($insert, $changedAttributes)
    {
        parent::afterSave($insert, $changedAttributes); // TODO: Change the autogenerated stub

        $years = [
            (Int)(date('Y')),
            date('Y')-1,
            date('Y')-2,
            date('Y')-3,
            date('Y')-4
        ];

        foreach ($years as $year){
            ${'el1_'.$year} = '';
            ${'el2_'.$year} = '';
            ${'pro_'.$year} = '';
        }

        $pogreshnost = 1;

        $check = true;

        $array = self::findAll(['id_child' => $this->id_child]);

        $years_fact = [];
        if (!empty($array)){
            foreach ($array as $item){
                $years_fact[] = (Int)date('Y', strtotime($item->dat));
            }
            foreach ($years as $year){
                if (!in_array($year, $years_fact)){
                    $check = false;
                    break;
                }else{
                    foreach ($array as $item){
                        if ($year == (Int)date('Y', strtotime($item->dat)) && in_array((Int)date('Y', strtotime($item->dat)),$years)){
//                            \Yii::error( $item->dat );
//                            \Yii::error( (Int)($item->el2) . '*******' );
//                            \Yii::error( trim($item->el1) . '*******' );
                            ${'el1_'.$year} = trim($item->el1);
                            ${'el2_'.$year} = trim($item->el2);
                            ${'pro_'.$year} = '';

                            if ((Int)$item->el2 == 0 && !empty(trim($item->el1))) {
                                \Yii::error( $year . ' Отрицат' );
                                ${'pro_'.$year} = 'Отрицат';
                            }
                            if (((Int)$item->el2 > 0 && (Int)$item->el2 < 5) || trim($item->el1) == 'ar'){
                                \Yii::error( $year . ' Сомнит' );
                                ${'pro_'.$year} = 'Сомнит';
                            }
                            if ((Int)$item->el2 > 4 && (Int)$item->el2 < 17 && trim($item->el1) == 'p'){
                                \Yii::error( $year . ' Положит' );
                                ${'pro_'.$year} = 'Положит';
                            }
                            if ((Int)$item->el2 > 16 && trim($item->el1) == 'p'){
                                \Yii::error( $year . ' Гипер' );
                                ${'pro_'.$year} = 'Гипер';
                            }
                        }
                    }
                }
            }

            $el2_y = ${'el2_'.$years[0]};
            $el2_y1 = ${'el2_'.$years[1]};
            $el2_y2 = ${'el2_'.$years[2]};
            $el2_y3 = ${'el2_'.$years[3]};
            $el2_y4 = ${'el2_'.$years[4]};

            $el1_y = ${'el1_'.$years[0]};
            $el1_y1 = ${'el1_'.$years[1]};
            $el1_y2 = ${'el1_'.$years[2]};
            $el1_y3 = ${'el1_'.$years[3]};
            $el1_y4 = ${'el1_'.$years[4]};

            $pro_y = ${'pro_'.$years[0]};
            $pro_y1 = ${'pro_'.$years[1]};
            $pro_y2 = ${'pro_'.$years[2]};
            $pro_y3 = ${'pro_'.$years[3]};
            $pro_y4 = ${'pro_'.$years[4]};



//            if ($check){
            if (true){
                $viraj = false;
                $min = 0;
                $tubik = false;
                $el2_current_minus_el2_before_current = (Int)($el2_y) - (Int)($el2_y1);

                if ($pro_y1 == 'Отрицат' && $pro_y == 'Положит'){
                    $viraj = true;
                }

                if (!empty($el2_y4) && ($el1_y == 'p' && $el1_y1 == 'p' && $el1_y2 == 'p' && $el1_y3 == 'p')){
                    $min = min([$el2_y, $el2_y1, $el2_y2, $el2_y3]);
                }

                if ($el1_y == 'p' && $el1_y1 == 'p' && ($el2_current_minus_el2_before_current > 6)) $tubik = true;

                if ($el1_y == 'p' &&
                    $el1_y1 == 'p' &&
                    $el1_y2 == 'p' &&
                    $el1_y3 == 'p' &&
                    in_array($el2_current_minus_el2_before_current, range(1,5))) $tubik = true;

                if ($pro_y1 == 'Положит' &&
                    $pro_y == 'Положит' &&
                    in_array($el2_current_minus_el2_before_current, range(1,5)) &&
                    (Int)($el2_y2) > 0 && (Int)($el2_y3) > 0) $tubik = true;

                if ($el1_y == 'p' &&
                    $el1_y1 == 'p' &&
                    $el1_y2 == 'p' &&
                    $el2_y >= 12 &&
                    $el2_y1 >= 12 &&
                    $el2_y2 >= 12) $tubik = true;

                if (($pro_y1 == 'Отрицат' || $pro_y1 == 'Сомнит' || empty($el1_y1)) && $pro_y == 'Положит' && count($array) > 3) $tubik = true;

                if ($el2_y >= 17) $tubik = true;

                if ($min != 0 &&
	                ($el2_y >= $min && $el2_y <= ($min + $pogreshnost)) &&
	                ($el2_y1 >= $min && $el2_y1 <= ($min + $pogreshnost)) &&
	                ($el2_y2 >= $min && $el2_y2 <= ($min + $pogreshnost)) &&
	                ($el2_y3 >= $min && $el2_y3 <= ($min + $pogreshnost)))
                    $tubik = true;

                if (strpos($el1_y,'отказ') !== false){
                    $ttt = MantuN_new::find()->where(['id_child' => $this->id_child,'status_ptd' => 0])->one();
                    if (empty($ttt)){
                        $model_mantu_n_new = new MantuN_new([
                            'id_child' => $this->id_child,
                            'pred_diagnoz' => 'отказ от р.Манту'
                        ]);

                        if (!$model_mantu_n_new->save()){
                            \Yii::error('Unable to save model: ' . VarDumper::dumpAsString($model_mantu_n_new->getErrors()) . PHP_EOL . VarDumper::dumpAsString($model_mantu_n_new->getAttributes()), __METHOD__);
                        }
                    }

                }elseif($tubik || $viraj){
                    $ttt = MantuN_new::find()->where(['id_child' => $this->id_child,'status_ptd' => 0])->one();
                    if (empty($ttt)){
                        $model_mantu_n_new = new MantuN_new([
                            'id_child' => $this->id_child
                        ]);

                        if (!$model_mantu_n_new->save()){
                            \Yii::error('Unable to save model: ' . VarDumper::dumpAsString($model_mantu_n_new->getErrors()) . PHP_EOL . VarDumper::dumpAsString($model_mantu_n_new->getAttributes()), __METHOD__);
                        }
                    }

                }


                /*$arr = [
                    '2020' => [
                        'el1_2020' => $el1_2020,
                        'el2_2020' => $el2_2020,
                    ],
                    '2019' => [
                        'el1_2019' => $el1_2019,
                        'el2_2019' => $el2_2019,
                    ],
                    '2018' => [
                        'el1_2018' => $el1_2018,
                        'el2_2018' => $el2_2018,
                    ],
                    '2017' => [
                        'el1_2017' => $el1_2017,
                        'el2_2017' => $el2_2017,
                    ],
                    '2016' => [
                        'el1_2016' => $el1_2016,
                        'el2_2016' => $el2_2016,
                    ],

                ];*/

                \Yii::error( $viraj );
                \Yii::error( $min );


            }

        }

    }
}
